      PARAMETER NOPT=14, NPOINT=5001

      INTEGER OPENED

      CHARACTER*4  STAR
      CHARACTER*3  XBTYPE, YBTYPE, ZBTYPE
      CHARACTER*80 TITLE, TITLEX, TITLEY, TITLEZ, EOF, TITXUP, OPTION,
     %             WORD
      CHARACTER*5  ALPHA1(NOPT)
      CHARACTER*30 DLAB(10)
      DIMENSION XP(NPOINT),YP(NPOINT),Z(100),C(100),Z1(100),C1(100)
      LOGICAL ABC

      COMMON /XAXN/ DX, XDIV
      COMMON /YAXN/ DY, YDIV
      COMMON /ZAXN/ DZ, ZDIV, ZMIN, ZMAX, ZLEN, ZINC
      COMMON /TITL/ TITLE,TITLEX,TITLEY,XBTYPE,YBTYPE
      COMMON /ZAXC/ TITLEZ,ZBTYPE

      DATA OPENED/0/
      DATA EOF/'@EOF'/,IFIRST/0/,IERR/0/
C
C
C
      DATA LUIN, LUPLP, LUPLT, LUTLAVR, LUMODE /9,10,14,15,16/
      DATA ALPHA1/'TLRAN','GROUP','TLAVR','TLDEP','TLAVF','ANGLE','PHASE
     *','CONDR','CONFR','PROFL','MODES','CONDA','HORWN','PARAM'/
      DATA WORD(1:7)/'SNAPRD '/
C
C
C       DESCRIPTION OF INPUT PARAMETERS
C
C    TITLE     TEXT STRING UP TO 80 CHRS. IT IS WRITTEN 
C              ON THE UPPER LEFT PART OF THE GRAPH
C    TITXUP    TEXT STRING UP TO 80 CHRS. IT IS WRITTEN ON THE
C              UPPER PART OF THE GRAPH (CENTERED)
C    IGRIDT    = 1 A GRID IS PLOTTED
C              = 0 NO GRID IS PLOTTED
C    XLEN      LENGTH OF X AXIS IN CM
C
C    YLEN      LENGTH OF Y AXIS IN CM
C
C    XLEFT     VALUE OF X AT THE AXIS ORIGIN
C
C    XRIGHT    VALUE OF X AT THE AXIS END
C
C    XINC      STEP INTERVAL IN USERS UNIT
C
C    XDIV      FACTOR APPLIED ON VALUES APPEARING ON THE AXIS
C
C    TITLEX    TEXT ON X AXIS
C
C    XBTYPEE      "LIN" = LINEAR AXIS
C              "LOG" = LOGARITHMIC AXIS
C    YDOWN     VALUE OF Y AT THE AXIS ORIGIN
C
C    YUP       VALUE OF Y AT THE AXIS END
C
C    YINC      STEP INTERVAL IN USERS UNIT
C
C    YDIV      FACTOR APPLIED ON VALUES APPEARING ON THE AXIS
C
C    TITLEY    TEXT ON Y AXIS
C
C    YTYP      "LIN" = LINEAR AXIS
C              "LOG" = LOGARITHMIC AXIS
C
C    NC        NUMBER OF CURVES ON SAME GRAPH
C
C    NPT       NUMBER OF DATA POINTS TO BE PLOTTED
C
C    INDEX     CURVE IDENTIFIER
C
C    XOFF      OFFSET ON X AXIS
C
C    DX        .EQ. 0 VALUES TO BE SUPPLIED
C              .NE. 0 INCREMENT BETWEEN VALUES
C
C    YOFF      OFFSET ON Y AXIS
C
C    DY        .EQ. 0 VALUES TO BE SUPPLIED
C              .NE. 0 INCREMENT BETWEEN VALUES
C
C    DLAB      CHARACTER ARRAY WHICH CONTAINS LABELS FOR PLOT
C
C    LUPLP     OUTPUT FILE WITH PARAMETERS
C
C    LUPLT     OUTPUT FILE WITH ACTUAL DATA TO BE PLOTTED
C
C
  120 FORMAT(A4)
  160 FORMAT(1H ,I8,10X,A30)
  200 FORMAT(A80)
  230 FORMAT(A3)
  260 FORMAT('PLOTFILE.DAT',16(' '))
  400 FORMAT(1X,' OUTPUT DEVICE FOR BATCH IS: ',A2,' (',A3,')')
  830 FORMAT(1X,F9.3)
  840 FORMAT('R = ',F7.1,'km$')
  850 FORMAT('SD= ',F7.1,'m$')
  860 FORMAT('RD= ',F7.1,'m$')
  870 FORMAT('F = ',F7.1,'Hz$')  
  905 FORMAT(1H ,//,'  EXECUTION OF OPTION : "',A5,'" IS NOT ALLOWED ',
     $/,'  FOR LESS THAN TWO FREQUENCIES')
  970 FORMAT('SV (m/s)$')
  980 FORMAT('Depth (m)$')
  990 FORMAT('Range (km)$')
C
C   1=  TLRAN
C   2=  GROUP
C   3=  TLAVR
C   4=  TLDEP
C   5=  TLAVF
C   6=  ANGLE
C   7=  PHASE
C   8=  CONDR
C   9=  CONFR
C  10=  PROFL
C  11=  MODES
C  12=  CONDA
C  13=  HORWN
C  14=  PARAM
C  15=  PROFL,RDP
C

      INQUIRE(FILE='PLOTFILE.DAT',EXIST=ABC)
      IF(.NOT.ABC)   GO TO 9000
      OPEN(UNIT=LUIN,FILE='PLOTFILE.DAT',
     % STATUS='OLD',
     % FORM='FORMATTED')
         
      MODULO=1024
      WRITE(LUPLP,160) MODULO,       ' MODULO'
C
      WRITE(LUPLT,120) EOF,          ' @EOF  '
      REWIND LUPLT    

      GO TO 1100

 1000 CONTINUE
      READ(LUIN,120) STAR
 1100 CONTINUE
      READ(LUIN,200,END=9000) OPTION
      IF(OPTION(1:4).EQ.'@EOF')   STOP ' END OF CONVERT.FOR '
      WORD(8:80)=OPTION(1:73)
      IF(OPTION(1:9).EQ.'PROFL,RDP')   GO TO 3015
C
C
C
C
C
C
      READ(LUIN,200) TITLE
      READ(LUIN,*) F,SD,RD,RR,HGT
      READ(LUIN,200) TITLEX
      READ(LUIN,230) XBTYPE
      READ(LUIN,*) XLEFT,XRIGHT,XSCALE,XINC,XDIV
      READ(LUIN,200) TITLEY
      READ(LUIN,230) YBTYPE
      READ(LUIN,*) YUP,YDOWN,YSCALE,YINC,XDIV
      READ(LUIN,*)NP,NTIMES
      IF(NP.GT.0 )THEN
           READ(LUIN,*)(XP(I),I=1,NP)
      END IF
C
C
      DO 1200 I=80,1,-1
 1200 IF(TITLE(I:I) .NE. ' ') GOTO 1300
 1300 TITLE(I+1:I+1)='$'      
C
      DO 1400 I=80,1,-1
 1400 IF(TITLEX(I:I) .NE. ' ') GOTO 1500
 1500 TITLEX(I+1:I+1)='$'     
C
      DO 1600 I=80,1,-1
 1600 IF(TITLEY(I:I) .NE. ' ') GOTO 1700
 1700 TITLEY(I+1:I+1)='$'
C
      TITXUP=' '
      DO 2000   I=1,NOPT
      IF(OPTION(1:5).EQ.ALPHA1(I))
     % GO TO(3001,3002,3003,3004,3005,3006,3007,3008,3009,
     %       3010,3011,3012,3013), I
 2000 CONTINUE
C
      WRITE(6,*) OPTION
      STOP ' UNKNOWN OPTION NAME '
 3001 CONTINUE
      IFLAG=0
C
C     SET PARAMETERS FOR PLTFILE AND OPTION TLRAN
C
      XDIV=1.0E-3
      YDIV=1.0
      XOFF=0.0
      YOFF=0.0
      DX=0.0
      DY=0.0
      WRITE(DLAB(1),870) F
      WRITE(DLAB(2),850) SD
      WRITE(DLAB(3),860) RD
      XLEN=ABS((XLEFT-XRIGHT)/XSCALE)
      YLEN=ABS((YUP-YDOWN)/YSCALE)
      CALL PLTFILE(TITXUP,0,WORD,3,1,XLEN,YLEN,XLEFT,
     %             XRIGHT,XINC,YDOWN,YUP,YINC,DLAB,
     %             LUPLP,LUPLT)
C
      DO 4001   J=1,NTIMES
      READ(LUIN,*)F,SD,RD,RR,I3,I4,I5,R1,R2
      READ(LUIN,*)(YP(I),I=1,NP)
      CALL PLTF1(1,NP,1,XOFF,YOFF)
C
C
      CALL PLTF2(XP,1,NP)
      CALL PLTF2(YP,1,NP)
C
C
      
 4001 CONTINUE
      GO TO 1000
 3002 CONTINUE
C
C
C    SET PARAMETERS FOR PLTFILE AND OPTION GROUP
C
C
      FSTOP=0.0
      LIN5=0
      XDIV=1.0
      YDIV=1.0
      XOFF=0.0
      YOFF=0.0
      DX=0.0
      DY=0.0
      XLEN=ABS((XRIGHT-XLEFT)/XSCALE)
      YLEN=ABS((YUP-YDOWN)/YSCALE)
      CALL PLTFILE(TITXUP,0,WORD,0,NTIMES,XLEN,YLEN,
     % XLEFT,XRIGHT,XINC,YDOWN,YUP,YINC,DLAB,LUPLP,LUPLT)
      DO 4002   J=1,NTIMES
      READ(LUIN,*)F,SD,RD,RR,MINF,M,MM,R1,R2
      READ(LUIN,*) (YP(I),I=MINF,NP)
      NPTS=(NP-MINF)+1
      CALL PLTF1(M,NPTS,1,XOFF,YOFF)
      CALL PLTF2(XP,MINF,NP)
      CALL PLTF2(YP,MINF,NP)
      IF(J.EQ.NTIMES)   FSTOP=1.0
 4002 CONTINUE
      GO TO 1000
 3003 CONTINUE
C
C  SET PARAMETERS FOR OPTION "TLAVR"
C
      OPEN(UNIT=LUTLAVR,FILE='LUTLAVR.DAT',
     % STATUS='UNKNOWN',
     % FORM='FORMATTED')
C
      LIN= 0
      XDIV=1.0E-3
      YDIV=1.0
      DX=0.0
      DY=0.0
      XLEN=ABS((XLEFT-XRIGHT)/XSCALE)
      YLEN=ABS((YDOWN-YUP)/YSCALE)

      DO 4003   J=1,NTIMES
      READ(LUIN,*)F,SD,RD,RR,I3,I4,I5,R1,R2
      READ(LUIN,*) (YP(I),I=1,NP)
      WRITE(DLAB(J+1),850) SD
      WRITE(DLAB(1),870) F
      WRITE(LUTLAVR,*) (YP(I),I=1,NP)
4003  CONTINUE
      REWIND LUTLAVR

      CALL PLTFILE(TITXUP,0,WORD,NTIMES+1,NTIMES,XLEN,
     %             YLEN,XLEFT,XRIGHT,XINC,YDOWN,
     %             YUP,YINC,DLAB,LUPLP,LUPLT)       

      DO 4099 J=1,NTIMES
      READ(LUTLAVR,*) (YP(I),I=1,NP)

      CALL PLTF1(1,NP,1,XOFF,YOFF)
C
      CALL PLTF2(XP,1,NP)
      CALL PLTF2(YP,1,NP)
C
 4099 CONTINUE
      CLOSE(UNIT=LUTLAVR,STATUS='DELETE')
      GO TO 1000
C
 3004 CONTINUE
C
C   SET PARAMETERS FOR PLTFILE AND OPTION TLDEP
C
      
      DX=0.0
      DY=(XP(NP)-XP(1))/(NP-1)
      HMIN=DY
      XOFF=0.0
      XDIV=1.0
      YDIV=1.0
      WRITE(DLAB(1),870)F
      WRITE(DLAB(2),840)RR*1.0E-3
      WRITE(DLAB(3),850)SD
      XLEN=ABS((XLEFT-XRIGHT)/XSCALE)
      YLEN=ABS((YDOWN-YUP)/YSCALE)
      CALL PLTFILE(TITXUP,0,WORD,3,1,XLEN,YLEN,XLEFT,
     %             XRIGHT,XINC,YDOWN,YUP,YINC,DLAB,LUPLP,LUPLT)
      
C
C
      READ(LUIN,*)F,SD,RD,RR,I3,I4,I5,HORIG,R2
      READ(LUIN,*)(YP(I),I=1,NP)
      YOFF=XP(1)
      CALL PLTF1(1,NP,1,XOFF,YOFF)

      CALL PLTF2(YP,1,NP)
      GO TO 1000
 3005 CONTINUE
C
C
C    SET PARAMETERS FOR OPTION "TLAVF"
C
C
      IF( (XRIGHT-XLEFT) .LE. 1.0E-3) THEN 
        WRITE(6,905) OPTION
        IERR=1
        GOTO 5000
      END IF
      ISKIP=IFIX(RD)
      XOFF=0.0
      YOFF=0.0
      DX=0.0
      DY=0.0
      XDIV=1.0
      YDIV=1.0
      XLEN=(ALOG10(XRIGHT/XLEFT)/ALOG10(2.)*XSCALE)
      YLEN=(YDOWN-YUP)/YSCALE
      WRITE(DLAB(1),840) RR*1.0E-3
      WRITE(DLAB(2),850) SD
      CALL PLTFILE(TITXUP,0,WORD,2,1,XLEN,YLEN,XLEFT,XRIGHT,
     %             XINC,YDOWN,YUP,YINC,DLAB,LUPLP,LUPLT)
C
C
       CALL PLTF1(8,-NP,1,XOFF,YOFF)

5000  CONTINUE     

      READ(LUIN,*)F,SD,RD,RR,I3,I4,I5,R1,R2
      READ(LUIN,*)(YP(I),I=1,NP)
      IF ( IERR .EQ. 1) GOTO 1000
      CALL PLTF2(XP,1,NP)
      CALL PLTF2(YP,1,NP)
      GO TO 1000
C
C
 3006 CONTINUE
C
C    SET PARAMETERS FOR PLTFILE AND OPTION ANGLE
C
      WRITE(DLAB(1),870) F
      WRITE(DLAB(2),840) RR*1.0E-3
      WRITE(DLAB(3),850) SD
      WRITE(DLAB(4),860) RD
      XDIV=1.0
      YDIV=1.0
      DX=0.0
      DY=0.0
      XOFF=0.0
      YOFF=0.0
      XLEN=(XRIGHT-XLEFT)/XSCALE
      YLEN=(YDOWN-YUP)/YSCALE 
      CALL PLTFILE(TITXUP,0,WORD,4,1,XLEN,YLEN,XLEFT,XRIGHT,
     %             XINC,YDOWN,YUP,YINC,DLAB,LUPLP,LUPLT)

      READ(LUIN,*) F,SD,RD,RR,N1,MINMOD,I4,R1,R2
      READ(LUIN,*)(YP(I),I=1,NP)
      CALL PLTF1(N1+MINMOD-1,(NP-N1)+1,1,XOFF,YOFF)
C
      CALL PLTF2(XP,1,NP)
      CALL PLTF2(YP,1,NP)
      GO TO 1000
 3007 CONTINUE
C
C
C   SET PARAMETERS FOR PLTFILE AND OPTION PHASE
C
C
      READ(LUIN,*)F,SD,RD,RR,I3,I4,I5,WDEPTH,R2
      READ(LUIN,*)(YP(I),I=1,NP)
      XDIV=1.0
      YDIV=1.0
      DX=0.0
      DY=(XP(NP)-XP(1))/(NP-1)
      XOFF=0.0
      YOFF=XP(1)
      WRITE(DLAB(1),870) F
      WRITE(DLAB(2),840) RR*1.0E-3
      WRITE(DLAB(3),850) SD
      XLEN=(XRIGHT-XLEFT)/XSCALE
      YLEN=(YDOWN-YUP)/YSCALE 
      CALL PLTFILE(TITXUP,0,WORD,3,1,XLEN,YLEN,XLEFT,XRIGHT,XINC,
     %             YDOWN,YUP,YINC,DLAB,LUPLP,LUPLT)
C
C
      CALL PLTF1(-1,-NP,1,XOFF,YOFF)

      CALL PLTF2(YP,1,NP)
      GO TO 1000
 3008 CONTINUE
 3009 CONTINUE
 3010 CONTINUE
      READ(LUIN,*)F,SD,RD,RR,I3,I4,I5,H0,H0H1
      READ(LUIN,*)(YP(I),I=1,NP)
      GO TO 1000
C
C
 3011 CONTINUE
C
C   SET PARAMETERS FOR PLTFILE AND OPTION MODES
C
      H0=SD
      H1=RD
      R1=RR
C
      IF(YUP.EQ.YDOWN)   THEN
       IF(YDOWN.EQ.0.0)   THEN
        YDOWN=H0
       ELSE
        WRITE(6,*) ' WRONG Y AXIS DEFINITION FOR YMIN, YMAX VALUES '
        WRITE(6,*) ' DEFAULT VALUES ARE USED '
        YDOWN=H0
        YUP=0.
       END IF
      END IF
C
      WRITE(DLAB(1),830) F
      WRITE(DLAB(2),830)H0
      WRITE(DLAB(3),830)H1
      WRITE(DLAB(4),830)R1
      XDIV=1.0
      YDIV=1.0
      XOFF=0.0
      YOFF=0.0
      DX=0.0
      DY=0.0
      XLEN=(XRIGHT-XLEFT)/XSCALE
      YLEN=(YDOWN-YUP)/YSCALE
      CALL PLTFILE(TITXUP,0,WORD,4,NTIMES,XLEN,YLEN,
     %  XLEFT,XRIGHT,XINC,YDOWN,YUP,YINC,DLAB,LUPLP,LUPLT)
      IF(OPENED .EQ. 0 )   THEN
       OPEN(UNIT=LUMODE,FILE='EIGFUN.DAT',STATUS='OLD',
     & FORM='FORMATTED')
       OPENED=1
      END IF
      CALL MOD_PLTF2(YP,NTIMES,LUMODE,LUPLT)
      GO TO 1000
 3012 CONTINUE
 3013 CONTINUE
      GO TO 1000
C
C
 3015 CONTINUE
C
C  SET PARAMETERS FOR PLTFILE AND OPTION PROFL
C
      READ(LUIN,200) TITLE
      READ(LUIN,*) XLEFT,XRIGHT,XLEN,XINC
      READ(LUIN,*) YUP,YDOWN,YLEN,YINC
      READ(LUIN,*) ZMIN,ZMAX,ZLEN,ZINC
      READ(LUIN,*) ITOSEC

C
      XBTYPE='LIN'
      YBTYPE='LIN'
      ZBTYPE='LIN'
      WRITE(TITLEZ,970)
      WRITE(TITLEX,990)
      WRITE(TITLEY,980)
      TITXUP=' '
      XDIV=1.0
      YDIV=1.0
      ZDIV=1.0
      YOFF=0.0
      DX=0.0 
      DY=0.0
       CALL PLTFILE(TITXUP,0,WORD,0,ITOSEC,XLEN,YLEN,
     %  XLEFT,XRIGHT,XINC,YDOWN,YUP,YINC,DLAB,LUPLP,LUPLT)
     
C
       DO 3018 IK=1,ITOSEC
       READ(LUIN,*) NH0,H0,RANGE
       DO 3017 IKK=1,NH0
       READ(LUIN,*)Z(IKK),C(IKK)
 3017  CONTINUE
      READ(LUIN,*)NH1,A1,A2,A3
      IF(NH1. LE. 0) THEN
         CALL PLTF1(1,NH0,1,RANGE,YOFF)
         CALL PLTF2(Z,1,NH0)
         CALL PLTF2(C,1,NH0)
      ELSE
         CALL PLTF1(1,NH0+NH1,1,RANGE,YOFF)
         DO 3019 II=NH0+1,NH0+NH1
         READ(LUIN,*) Z(II),C(II)
         Z(II)=Z(II)+Z(NH0)
 3019    CONTINUE    
         CALL PLTF2(Z,1,NH0+NH1)
         CALL PLTF2(C,1,NH0+NH1)
       END IF
 3018 CONTINUE
      GO TO 1000
 9000 CONTINUE
      END


      SUBROUTINE MOD_PLTF2(EIGF,MODQTY,LUMODE,LUPLT)
      DIMENSION EIGF(1)

  320 FORMAT(1X,5(F10.7,2X))
  420 FORMAT(I6,3X,' MINIMUM ORDER MODE',/,
     & I6,3X,' NUMBER OF MESH POINTS IN THE WATER LAYER ',/,
     & I6,3X,' NUMBER OF MESH POINTS IN THE SEDIMENT LAYER ')

       READ(LUMODE,*) MINMOD
       READ(LUMODE,*) LI0
       READ(LUMODE,*) LI1
       WRITE(LUPLT,420) MINMOD,LI0,LI1

       DO 3000   M=1,MODQTY

         DO 1000   I1=1,LI0,51
         I2=MIN0(I1+51-1,LI0)
         READ(LUMODE,320) (EIGF(JK),JK=1,I2-I1+1)
         WRITE(LUPLT,320) (EIGF(JK),JK=1,I2-I1+1)
 1000    CONTINUE
         IF(LI1.GT.0)   THEN
          DO 2000   I1=LI0+1,LI0+LI1,51
          I2=MIN0(I1+51-1,LI0+LI1)
          READ(LUMODE,320) (EIGF(JK),JK=1,I2-I1+1)
          WRITE(LUPLT,320) (EIGF(JK),JK=1,I2-I1+1)
 2000     CONTINUE
         END IF

 3000 CONTINUE

      RETURN
      END
