      SUBROUTINE INPUT(TITLE,FF,NFF,NSECT,*,ALPHA1,ALPHA2,
     &                 MSP,NINC,NXVAL,C1ND1,PULSD,NK)
C
C   NDEP IS NUMBER OF DEPTHS ALLOWED IN SAMPLING
C   THE SOUND SPEED PROFILE, NFF IS NUMBER OF INPUT FREQUENCIES
C
C   NDEP IS ALSO DEFINED IN SUB DRIVER AND MODE
C

      PARAMETER (NDEP=201)

      INTEGER REREAD

      DOUBLE PRECISION DL2,CC0

      INCLUDE 'COMMON.FOR'

      CHARACTER*3 ALPHA2(6), OPT(5), VAXFPS
      CHARACTER*4 TITLE(20)
      CHARACTER*5 ALPHA1(NOPT), OPTION, MODEL
      CHARACTER*6 AXIS
      CHARACTER*80 WORD

      DIMENSION FF(NFF), BUFFIN(4)

      COMMON /A/ C0(NDEP),C1(NDEP),Z0(NDEP),Z1(NDEP),ND0,ND1
      COMMON /AB/ BETA(3),SCATT(2),C2S
      COMMON /CFIELD/ FLDRD(3),PULRD(3)
      COMMON /CONTUR/ CNTR1(3,3),HMAX,HMIN
      COMMON /FFP/ FFP, DLRAN, P0
      COMMON /G/ R0,R1,R2,C2,H0,H1,FACT0,FACT1,C11
      COMMON /I/ SECD(NOPT,3)
      COMMON /LUNIT/ MSOURC,MODOLD,MODNEW,LUPRT
      COMMON /N/ MINMOD,MAXMOD,HSTART,NFREQ
      COMMON /NRNGD/ HNEW,HOLD,RSTART,REND,SLNGTH,IND1
      COMMON /PULSED/ FMIN, FMAX, DELTAT, NFFT
      COMMON /SAVE/ STORE(NOPT),IFREQ
      COMMON /SOFTWR/ VAXFPS,MODEL
      COMMON /FLAGS/ PLANE, EK0, SQEK0
      DATA FLAG1/0.0/
      DATA LUIN /20/
C
C   ARRAY ALPHA1 CONTAINS THE OPTION CODES.
C
C
C   ALPHA1(1)=  TLRAN
C   ALPHA1(2)=  GROUP
C   ALPHA1(3)=  TLAVR
C   ALPHA1(4)=  TLDEP
C   ALPHA1(5)=  TLAVF
C   ALPHA1(6)=  ANGLE
C   ALPHA1(7)=  PHASE
C   ALPHA1(8)=  CONDR
C   ALPHA1(9)=  CONFR
C   ALPHA1(10)= PROFL
C   ALPHA1(11)= MODES
C   ALPHA1(12)= CONDA
C   ALPHA1(13)= HORWN
C   ALPHA1(14)= PARAM
C   ALPHA1(15)= FREE FOR NEW OPTION
C   ALPHA1(16)= PULSE
C   ALPHA1(17)= FREE FOR NEW OPTION
C   ALPHA1(18)= FREE FOR NEW OPTION
C
C
C   ARRAY ALPHA2 CONTAINS THE SUB-OPTION CODES
C
C
C   ALPHA2(1)=  '   '
C   ALPHA2(2)=  'PRT'
C   ALPHA2(3)=  'PLT'
C   ALPHA2(4)=  'COL'
C   ALPHA2(5)=  'COH'
C   ALPHA2(6)=  'INC'
C
C   OPT IS THE MATRIX WHERE THE INPUT OPTIONS ARE READ LINE PER LINE
C
C
C   SECD IS THE MATRIX WHICH CONTAINS INFORMATION ABOUT RMIN,RMAX AND DELR
C   FOR TLRAN AND TLAVR OPTIONS
C
C
C
C   CNTR1 IS THE MATRIX THAT CONTAINS THE VARIOUS ZMIN, ZMAX
C    AND ZLEV COMBINATIONS FOR CONTOURED REPRESENTATIONS.
C
  105 FORMAT(1H ,//,'  INPUT FREQUENCIES:',/)
  110 FORMAT(1H ,2X,F10.2,' HZ')
  115 FORMAT(1H ,/,'  CALCULATION IS ALLOWED ONLY FOR POSITIVE FREQUENCY
     * VALUES.',/,'  EXECUTION IS TERMINATED')
  118 FORMAT(1H ,/,'   THE FOLLOWING INPUT FREQUENCY VALUE IS SPECIFIED
     *MORE THEN ONCE: ',F7.2,' HZ',/,'   THE INPUT FREQUENCY IS NOW UNIQ
     *UELY SPECIFIED.')
  120 FORMAT(20A4)
  125 FORMAT(A80)
  140 FORMAT(A5,1X,5(A3,1X))
  160 FORMAT(1H ,//,'  DENSITY OF SEDIMENT LESS THAN OR EQUAL TO ZERO IS
     $ NOT ACCEPTED',/,'  EXECUTUION IS TERMINATED')
  170 FORMAT(1H ,//,'  DENSITY OF BOTTOM LAYER LESS THAN OR EQUAL TO ZER
     $O IS NOT ACCEPTED',//,'  EXECUTION IS TERMINATED')
  220 FORMAT(1H ,/,' MATRIX FLAG  ',/,8X,' Y=1;N=0 ',5(2X,A3,3X))
  240 FORMAT(1H ,A5,1X,F7.0,5F8.0)
  260 FORMAT(1H ,/,' MATRIX SRD ',/,'  OPTION ',A6)
  280 FORMAT(1H ,/,' MATRIX SECD ',/,'          RMIN     RMAX     DELR')
  300 FORMAT(1H ,A5,2X,E9.2,2E11.2)
  380 FORMAT(1H ,/,' MATRIX CNTR1',/,10X,'  ZMIN     ZMAX     ZINC    ')
  400 FORMAT(1H ,A5,3X,3E9.2)
  410 FORMAT(1H ,/,' EXECUTION TERMINATED BECAUSE OF ARRAY SIZE LIMITATI
     *ONS .')
  415 FORMAT(1H ,//,'  REVISE THE "X" AXIS DEFINITION FOR OPTION "TLAVF"
     $',/,'  THE NUMBER OF SUBDIVISIONS CANNOT EXCEED', I3,' .')
  420 FORMAT(1H ,//,'  REVISE THE "Y" AXIS DEFINITION FOR OPTION ',A5,'.
     $',/,'  THE NUMBER OF SUBDIVISIONS CANNOT EXCEED', I3,' .')
  421 FORMAT(1H ,//,'  ZERO FREQUENCY VALUE NOT ALLOWED IN "Y" AXIS FOR
     $OPTION ',A5,/,'  EXECUTION IS TERMINATED')
  430 FORMAT(1H ,/,' NUMBER OF INPUT FREQUENCIES (NFREQ)= ',I3,/,' SIZE
     *OF FREQUENCY ARRAY (NFF) =',I2)
  450 FORMAT(1H ,/,' NUMBER OF SOUND SPEED PROFILE DEPTHS IN THE ',/,' W
     *ATER LAYER (ND0) =',I3,/,' SIZE OF ARRAY (NDEP)= ',I3)
  460 FORMAT(1H ,' REVISE THE FOLLOWING INPUT LINE:',/,2X,A5,1X,5(A3
     *,1X),/,' EXECUTION IS TERMINATED')
  461 FORMAT(1H ,' REVISE THE FOLLOWING INPUT LINE:',/,2X,A80,/
     *,' EXECUTION IS TERMINATED')
  470 FORMAT(1H ,/,' NUMBER OF SOUND SPEED PROFILE DEPTHS IN THE',/,' TO
     *P BOTTOM LAYER (ND1)= ',I3,' SIZE OF ARRAY (NDEP)= ',I3)
  480 FORMAT(1H ,//,' THE SOURCE DEPTH SPECIFIED FOR OPTION "',A5,'" IS
     % NOT CORRECT.',/,' SOURCE DEPTH =',F10.3,' M',
     */,' WATER DEPTH  =',F10.3,' M',/,' EXECUTION IS TERMINATED')
  481 FORMAT(1H ,//,' THE RECEIVER DEPTH SPECIFIED FOR OPTION "',A5,'" I
     *S NOT CORRECT.',/,' RECEIVER DEPTH  =',F10.3,' M',
     */,' MAX WATER DEPTH =',F10.3,' M',/,' EXECUTION IS TERMINATED')
  500 FORMAT(1H ,'MAXIMUM NUMBER OF SOURCE/RECEIVER DEPTH COMBINATIONS
     *',/,' HAS BEEN REACHED. ',/,' EXECUTION IS TERMINATED.')
  600 FORMAT(1H ,//,' SHEAR SPEED IN SECTOR # ',I2,' IS TOO HIGH.',/,' E
     *XECUTION IS TERMINATED')
  650 FORMAT(1H ,//,' THE ABSORPTION COEFFICIENT FOR THE SHEAR VELOCITY
     *IN SECTOR # ',I2,' IS TOO HIGH',/,' EXECUTION IS TERMINATED')
  660 FORMAT(1H ,//,' REVISE INPUT SOUND SPEED PROFILE FOR THE WATER DEP
     *TH.',//,5X,'    DEPTH(M)',4X,'  SOUND SPEED(M/S) ')
  670 FORMAT(1H ,5X,F10.3,9X,F10.3)
  680 FORMAT(1H ,/, ' EXECUTION IS TERMINATED.')
  690 FORMAT(1H ,//,' REVISE INPUT SOUND SPEED PROFILE FOR THE TOP BOTTO
     *M LAYER.',//,5X,'    DEPTH(M)',4X,'  SOUND SPEED(M/S) ')
  710 FORMAT(1H ,///,'  REVISE RMIN,RMAX AND/OR XAXIS INPUT VALUES FOR '
     *,A6,'OPTION.',/
     */,' CALCULATION:',3X,'MINIMUM RANGE',2X,F11.2,2X,'MAXIMUM RANGE',3
     *X,F11.2,
     */,' PLOT AXIS  :',3X,'LEFT END VALUE',1X,F11.2,2X,'RIGHT END VALUE
     *',1X,F11.2,
     */,'  EXECUTION IS TERMINATED',//)
  720 FORMAT(1H ,///,'  REVISE FREQUENCY AND/OR XAXIS INPUT VALUES FOR '
     *,A6,'OPTION.',/
     */,' CALCULATION:',3X,'MINIMUM FREQ ',2X,F11.2,2X,'MAXIMUM FREQ ',3
     *X,F11.2,
     */,'  "X" AXIS  :',3X,'LEFT END VALUE',1X,F11.2,2X,'RIGHT END VALUE
     *',1X,F11.2,
     */,'  EXECUTION IS TERMINATED',//)
  721 FORMAT(1H ,///,'  REVISE FREQUENCY AND/OR YAXIS INPUT VALUES FOR '
     *,A6,'OPTION.',/
     */,' CALCULATION:',3X,'MINIMUM FREQ ',2X,F11.2,2X,'MAXIMUM FREQ ',3
     *X,F11.2,
     */,'  "Y" AXIS  :',3X,'MIN VALUE',6X,F11.2,3X,'MAX VALUE',7X,F11.2,
     */,'  EXECUTION IS TERMINATED',//)
  740 FORMAT(1H ,//,'  EXECUTION OF OPTION : "',A5,'" IS NOT ALLOWED ',
     $/,'  FOR LESS THAN TWO FREQUENCIES')
738   FORMAT(1X,'*** WARNING ***',/,' BECAUSE OF ARRAY SIZE ',
     $' LIMITATIONS THE TOTAL NUMBER OF RANGE STEPS ',/,
     &' FOR OPTION "TLAVF" IS REDUCED TO ',1X,I2)
739   FORMAT(1X,'    INPUT FREQUENCIES (HZ): ',/)
741   FORMAT(1X,'  ',I3,')  ','FREQ=',F10.2,/)
742   FORMAT(1X,'Y AXIS SPECIFICATIONS (HZ):',//,
     *1X,'FMIN =',F10.2,2X,'FMAX =',F10.2,/)
  752 FORMAT(1X,/,' WARNING: MAX WATER DEPTH FOR Y AXIS IN',
     &' CONDR OPTION MUST NOT',/,9X,' EXCEED THE MINIMUM WATER DEPTH',
     &' ALONG THE PROPAGATION PATH ',/,
     &9X,' MINIMUM WATER DEPTH = ',F10.3,' M',/,
     &9X,' Y AXIS DEFINITION   = ',F10.3,' M',/,
     &9X,' THE Y AXIS DEFINITION IS ACCORDINGLY REDUCED. ')
  753 FORMAT(1X,/,' OPTION CONDR CAN BE COMPUTED ONLY OVER',
     &' CONSTANT DEPTH  ENVIRONMENT.',/,
     &' MINIMUM WATER DEPTH = ',F10.3,' M',/,
     &' MAXIMUM WATER DEPTH = ',F10.3,' M')
  760 FORMAT(1H ,//,' ERROR FOR OPTION ',A6,':',/)
  780 FORMAT(1H ,' MISSING SPECIFICATION OF OUTPUT TYPE')
  790 FORMAT(1X,' *** WARNING ***',/,
     & '  * MAX ALLOWED NUMBER OF RANGE STEPS FOR OPTION "'
     & ,A5,'" IS ',I6,'.',/,
     & '  * REVISE RMIN,RMAX,RSTEP DEFINITION. ',/,
     & '  * EXECUTION IS TERMINATED ')
  800 FORMAT(1H ,' MISSING SPECIFICATION OF CALCULATION TYPE')
  820 FORMAT(1H ,//,'  MISSING DEPTH SPECIFICATION FOR OPTION "',A5,
     *'"',/,'  EXECUTION IS TERMINATED')
  840 FORMAT(1H ,/,'   THE AXES FOR THE OPTION ',A5,' ARE TOO BIG.',/,'
     *  THE MAXIMUM AVAILABLE PAPER SIZE (CM) ALLOWS FOR:',/,'   (AXMAX+
     *7.0,AXMIN+6.0).LE.(',F6.2,',',F6.2,')',/,'   THE ACTUAL AXES LENGT
     *H IS:')
  860 FORMAT(1H ,'  AXMAX ("X" AXIS) =',F8.2,' CM',/,'   AXMIN ("Y" AXIS
     *) =',F8.2,' CM')
  880 FORMAT(1H ,'  AXMAX ("Y" AXIS) =',F8.2,' CM',/,'   AXMIN ("X" AXIS
     *) =',F8.2,' CM')
  890 FORMAT(1H ,//,'  NO OPTION CAN BE SPECIFIED MORE THAN ONCE.',
     $/,'  REVISE OPTION ',A5,' .')
  900 FORMAT(1H ,///,'  REVISE THE NUMBER OF INPUT FREQUENCIES')
  910 FORMAT(1H ,///,'  REVISE MINMOD,MAXMOD')
  915 FORMAT(1X,' WARNING: THIS PROGRAM VERSION ALLOWS'
     & ,' FOR A MAXIMUM OF ',I6,' MODES.')
  920 FORMAT(1H ,///,'  REVISE LI0,LI1')
  930 FORMAT(1H ,///,'  REVISE NUMBER OF SECTORS')
C  940 FORMAT(F15.3)
C
C
      DO 1000   K1=1,80,4
      K2=K1+3
      WORD(K1:K2)='    '
 1000 CONTINUE
C
      DO 1020   I=1,NFF
      FF(I)=0.0
 1020 CONTINUE
C
      DO 1040   I=1,NDEP
      C0(I)=0.0
      C1(I)=0.0
      Z0(I)=0.0
      Z1(I)=0.0
 1040 CONTINUE
C
      MLAYER=MSP-1
      READ(20,120)TITLE
      READ(20,*,ERR=1100)NFREQ
      GO TO 1150
 1100 WRITE(LUPRT,900)
      WRITE(LUPRT,680)
      RETURN 1
 1150 CONTINUE
      IF(NFREQ.LE.NFF)   GO TO 1200
      ITEMP=NFF
      WRITE(LUPRT,410)
      WRITE(LUPRT,430) ITEMP,NFREQ
      RETURN 1
C   INPUT FREQUENCIES ARE READ AND ARRANGED TO BE A
C   MONOTONIC INCREASING FUNCTION.
 1200 READ(20,*)(FF(I),I=1,NFREQ)
      IF(NFREQ.EQ.1)   GO TO 1450
      DO 1300   II=2,NFREQ
      I=II
 1250 CONTINUE
      IF(FF(I).GT.FF(I-1))   GO TO 1300
      TEMP=FF(I)
      FF(I)=FF(I-1)
      FF(I-1)=TEMP
      I=I-1
      IF(I.GT.1)   GO TO 1250
 1300 CONTINUE
C
C   LOOP TO REMOVE EVENTUAL REPETITIONS OF
C   FREQUENCY VALUES.
C
      I=1
      DO 1400   II=2,NFREQ
      IF(FF(I).EQ.FF(II))   GO TO 1350
      TEMP=FF(II)
      I=I+1
      FF(I)=TEMP
      GO TO 1400
 1350 WRITE(LUPRT,118) FF(I)
 1400 CONTINUE
      NFREQ=I
 1450 CONTINUE
      IF(FF(1).GT.0.0)   GO TO 1500
      WRITE(LUPRT,105)
      WRITE(LUPRT,110)(FF(I),I=1,NFREQ)
      WRITE(LUPRT,115)
      RETURN 1
 1500 CONTINUE
      READ(20,*,ERR=1525)MINMOD,MAXMOD
      IF(MINMOD.GT.0)   GO TO 1530
      FFP=1.0
      MINMOD=1
      GO TO 1530
 1525 WRITE(LUPRT,910)
      WRITE(LUPRT,680)
      RETURN 1
 1530 CONTINUE
C
      IF(MAXMOD.GT.MODEN)   THEN
      MAXMOD=MODEN
      WRITE(LUPRT,915) MAXMOD
      END IF
C
      READ(20,*,ERR=1535)SAVEF0,SAVEF1
      GO TO 1540
 1535 WRITE(LUPRT,920)
      WRITE(LUPRT,680)
      RETURN 1
 1540 CONTINUE
C
      WRITE(10)MINMOD,MAXMOD
C
C   READING AND STORING OF SECTOR DATA ON TEMPORARY FILE.
C
      READ(20,*,ERR=1620)NSECT
      GO TO 1640
1620  WRITE(LUPRT,930)
      WRITE(LUPRT,680)
      RETURN 6
1640  CONTINUE
C
      RST=0.
C
      DO 2800 I=1,NSECT
      FACT0=SAVEF0
      FACT1=SAVEF1
      READ(20,*)SLNGTH
      SLNGTH=SLNGTH*1.0E3
      RST=RST+SLNGTH
      READ(20,*)H0,SCATT
      IF(I.GT.1)GOTO 1650
      HMAX=H0
      HMIN=H0
      HSTART=H0
C NEEDED FOR CONTOUR OPTIONS
1650  IF(H0.GT.HMAX)HMAX=H0
      IF(H0.LT.HMIN)HMIN=H0
      ND0=1
      READ(20,*)Z0(1),C0(1)
      IF(Z0(1).NE.0.0)   THEN
      WRITE(LUPRT,660)
      WRITE(LUPRT,670)(Z0(ID),C0(ID),ID=1,ND0)
      WRITE(LUPRT,680)
      STOP
      END IF
 1750 CONTINUE
      ND0=ND0+1
      IF(ND0.GT.NDEP)   THEN
      ITEMP=NDEP
      WRITE(LUPRT,410)
      WRITE(LUPRT,450) ND0,ITEMP
      STOP
      END IF
      READ(20,*)Z0(ND0),C0(ND0)
      IF((Z0(ND0).LT.Z0(ND0-1)).OR.(Z0(ND0).GT.H0)) THEN
      WRITE(LUPRT,660)
      WRITE(LUPRT,670)(Z0(ID),C0(ID),ID=1,ND0)
      WRITE(LUPRT,680)
      STOP
      ELSE
      IF(Z0(ND0).LT.H0)   GO TO 1750
      END IF
C
C   THIS POINT IS REACHED WHEN Z0(ND0).EQ.H0
C
C   CALCULATION OF AVERAGE SOUND SPEED OF WATER LAYER
C
      CC0=0.
      ND0M1=ND0-1
      DO 1860   J=1,ND0M1
 1860 CC0=CC0+((C0(J)+C0(J+1))*(Z0(J+1)-Z0(J)))/2.0
      CC0=CC0/H0
C     READ(20,*)H1
      READ(20,125) WORD
      CALL RFFORM(WORD,80,BUFFIN,1,3,ISTAT)
      H1=BUFFIN(1)
      IF(H1.GT.0.0)   GO TO 1900
      ND1=0
      BETA(1)=0.0
      R1=0.0
      GO TO 2200
 1900 CONTINUE
C     BACKSPACE 20
C     READ(20,*)H1,R1,BETA(1)
      R1=BUFFIN(2)
      BETA(1)=BUFFIN(3)
      IF(R1.GT.0.0)   GO TO 1920
      WRITE(LUPRT,160)
      RETURN 1
 1920 CONTINUE
      ND1=1
      READ(20,*)Z1(1),C1(1)
      IF(Z1(1).EQ.0.0)   GO TO 2000
 1950 WRITE(LUPRT,690)
      WRITE(LUPRT,670)(Z1(ID),C1(ID),ID=1,ND1)
      WRITE(LUPRT,680)
      RETURN 1
 2000 CONTINUE
      ND1=ND1+1
      READ(20,*)Z1(ND1),C1(ND1)
      C1ND1=C1(ND1)
      IF(Z1(ND1).GE.Z1(ND1-1))   GO TO 2100
      WRITE(LUPRT,690)
      WRITE(LUPRT,670)(Z1(ID),C1(ID),ID=1,ND1)
      WRITE(LUPRT,680)
      RETURN 1
 2100 IF(ABS(Z1(ND1)-H1).LE.1.0E-5)   GO TO 2200
      IF(Z1(ND1).GT.H1)   GO TO 1950
      IF(ND1.LE.NDEP)   GO TO 2000
      ITEMP=NDEP
      WRITE(LUPRT,410)
      WRITE(LUPRT,470) ND1,ITEMP
      RETURN 1
 2200 CONTINUE
      READ(20,*)R2,BETA(2),C2
      IF(R2.GT.0.0)   GO TO 2250
      WRITE(LUPRT,170)
      RETURN 1
 2250 CONTINUE
      READ(20,*)BETA(3),C2S
      IF(C2S.LE.C2*SQRT(0.75))   GO TO 2300
      WRITE(LUPRT,600) I
      RETURN 1
 2300 IF(C2S.GT.0.0)   GO TO 2400
      B3S=0.0
      GO TO 2500
 2400 IF(BETA(3).LE.0.75*BETA(2)*(C2/C2S)**2)   GO TO 2500
      WRITE(LUPRT,650) I
      RETURN 1
 2500 CONTINUE
C
C   CALCULATION OF AVERAGE SOUND SPEED OF TOP BOTTOM LAYER
C
      CC1=0.
      IF(ND1.EQ.0)   GO TO 2700
      ND1M1=ND1-1
      DO 2600   J=1,ND1M1
 2600 CC1=CC1+((C1(J)+C1(J+1))*(Z1(J+1)-Z1(J)))/2.0
      CC1=CC1/H1
 2700 CONTINUE
C
      LI0=0
      LI1=0
C
      IF(MODEL.EQ.'SUPER')   THEN
       IF(IFIX(FACT0).GE.MSP)   THEN
C   SNAP INPUT TO BE ADAPTED TO SUPERSNAP
       WRITE(LUPRT,*) ' WARNING : SNAP INPUT IS ADAPTED TO SUPERSNAP'
       FACT0=1.0
       FACT1=1.0
       END IF
       IF(H1.EQ.0.0)   FACT1=0.0
       IF(FACT0.EQ.0.0)   FACT0=1.0
      ELSE
       IF(FACT0.LT.MSP)   THEN
C   SUPERSNAP INPUT TO BE ADAPTED TO SNAP
       WRITE(LUPRT,*) ' WARNING : SUPERSNAP INPUT IS ADAPTED TO SNAP'
       IF(FACT0.LE.0.0)   THEN
        FACT0=1.0
        FACT1=1.0
       END IF
       TEMP=(NDP/2)/(H0*FACT0*CC0+H1*FACT1*CC1)
       LI0=TEMP*H0*FACT0*CC0
       LI1=TEMP*H1*FACT1*CC1
       ELSE
       LI0=IFIX(FACT0)
       LI1=IFIX(FACT1)
       END IF
C  LI0 IS ADJUSTED TO BE AN INTEGER MULTIPLE OF 'MLAYER'.
       LI0=(((LI0-1)/MLAYER)+1)*MLAYER
 2710  IF((LI0+LI1).LE.(NDP-5))   GO TO 2720
       LI0=LI0-MLAYER
       GO TO 2710
 2720  CONTINUE
C  LI1 MAY NOT BE SMALLER THAN 2.
       IF(LI1.LT.2)   LI1=2
      END IF
C
      WRITE(10)R1,R2,H0,H1,LI0,LI1,ND0,ND1,SLNGTH
      WRITE(10)BETA,SCATT,CC0,CC1
C     WRITE(LUPRT,*)ND0
      DO 2740   J=1,ND0
C     WRITE(LUPRT,*)J,Z0(J)
      WRITE(10) Z0(J), C0(J)
 2740 CONTINUE
      IF(ND1.GT.0)   THEN
      DO 2760   J=1,ND1
      WRITE(10) Z1(J), C1(J)
 2760 CONTINUE
      END IF
 2800 WRITE(10)C2,C2S
      REWIND(10)
C
      REREAD=0
C
      KD=1
      KR=1
      KSRDP1=KSRD+1
 2900 CONTINUE
 3000 CONTINUE
      DO  3100   J=1,5
 3100 OPT(J)='   '
C
C
C   CHECK OF INPUT LINE TO DETERMINE REQUESTED OPTION
C
      IF(REREAD.EQ.0)   READ(20,125) WORD
      REREAD=0
      IF(WORD(1:4).EQ.'@EOF')   GO TO 7000
      READ(WORD,140)OPTION,(OPT(I),I=1,5)
      DO   4500   I=1,NOPT
      IF(OPTION .NE. ALPHA1(I))   GO TO 4500
      IF(FLAG(I,1) .LT. 1.0)   GO TO 3150
      WRITE(LUPRT,890) ALPHA1(I)
      FLAG1=-1.0
 3150 CONTINUE
      FLAG(I,1)=1.
C
C   CHECK OF INPUT LINE TO DETERMINE REQUESTED SUB-OPTIONS
C
      DO  3300   N=1,5
      DO  3200   M=1,6
      IF(OPT(N).eq.ALPHA2(M)) then
       FLAG(I,M)=1.
       GO TO 3300
      end if
 3200 CONTINUE
      if (opt(n).eq.'PLA') then
       PLANE = 1
       go to 3300
      end if
      GO TO 4500
 3300 CONTINUE
      OUTPUT=0.
      IF((FLAG(I,2).GT.0.0).OR.(FLAG(I,3).GT.0)) OUTPUT=1.   
C
      IF((ALPHA1(I).EQ.'GROUP'.OR.
     %    ALPHA1(I).EQ.'ANGLE'.OR.
     %    ALPHA1(I).EQ.'PHASE'.OR.
     %    ALPHA1(I).EQ.'PROFL'.OR.
     %    ALPHA1(I).EQ.'PULSE'.OR.
     %    ALPHA1(I).EQ.'MODES'.OR.
     %    ALPHA1(I).EQ.'HORWN'.OR.
     %    ALPHA1(I).EQ.'PARAM').AND.
     %    OUTPUT.GT.0.)   GO TO 3400
      COHINC=0.
      IF((FLAG(I,5).GT.0.0).OR.(FLAG(I,6).GT.0)) COHINC=1.   
      IF(OUTPUT+COHINC.GT.1.0)   GO TO 3400
      FLAG1=-1.0
      WRITE(LUPRT,760) ALPHA1(I)
      IF(OUTPUT.LT.1.0)   WRITE(LUPRT,780)
      IF(COHINC.LT.1.0)   WRITE(LUPRT,800)
 3400 CONTINUE
C  THE FOLLOWING LOOP READS EVENTUAL DEFINITION OF PLOT AXES.
 3500 CONTINUE
      READ(20,125)WORD
      IF(WORD(1:4).EQ.'@EOF')   GO TO 7000
C     BACKSPACE 20
C     READ(20,*,IOSTAT=ISTAT)DUMMY
      CALL RFFORM(WORD,80,DUMMY,1,1,ISTAT)
      IF(ISTAT.GT.0)   GO TO 3600
C     READ(LC,*,ERR=3600,END=7000)DUMMY
      IF((ALPHA1(I).NE.'PROFL').AND.(ALPHA1(I).NE.'MODES').AND.(ALPHA1(
     *I).NE.'GROUP').AND.(ALPHA1(I).NE.'PARAM'))   GO TO 4400
      REREAD=1
      GO TO 4400
 3600 CONTINUE
      IF(WORD(1:6).EQ.'XAXIS ')   GO TO 3800
      IF(WORD(1:6).EQ.'YAXIS ')   GO TO 4100
      IF(WORD(1:6).EQ.'SAXIS ')THEN
      IF(ALPHA1(I).EQ.'PROFL ')THEN
      WORD(1:6)='      '
      CALL RFFORM(WORD,80,AS(1),1,4,ISTAT)
      AS(5)=1.0
      GOTO 4200
      ELSE
      WRITE(LUPRT,*)' SAXIS NOT IN LEGAL CONTEXT'
      END IF
      END IF
      IF(WORD(1:6).NE.'FILE  ')   GO TO 3650
      STORE(I)=1.0
      GO TO 4200
 3650 CONTINUE
      IF((ALPHA1(I).NE.'PROFL').AND.(ALPHA1(I).NE.'MODES').AND.(ALPHA1(
     *I).NE.'GROUP').AND.(ALPHA1(I).NE.'PARAM'))   GO TO 3700
      REREAD=1
      GO TO 3000
3700  WRITE(LUPRT,461)WORD
      RETURN 1
C  CHECK FOR NO PLOT CASE.
 3800 CONTINUE
C     IF((FLAG(I,3).LT.1.0).AND.(STORE(I).LT.1.0))   GO TO 4200
      WORD(1:6)='      '
      CALL RFFORM(WORD,80,AX(I,1),NOPT,4,ISTAT)
      AX(I,5)=1.0
      CALL REVXAX(AX,I,NOPT)

      GO TO(3850,4200,3850,4200,4200,4200,4200,3850,3850,4200,
     &      4200,3850,4200,4200,4200,3820),I
 3820 CONTINUE
      CALL IPULSE(WORD,ALPHA1,FLAG,SECD,PULSD,NSD,NK,NOPT,
     & I,KSRD,ICF,HSTART,LUIN)
      REREAD=0
      GO TO 3000
C 
 3850 CONTINUE
      DO 3900   J=1,4
C   CONVERSION FROM KM TO M
 3900 AX(I,J)=AX(I,J)*1000.  
      GO TO 4200
C  CHECK FOR NO PLOT CASE.
 4100 CONTINUE
C     IF((FLAG(I,3).LT.1.0).AND.(STORE(I).LT.1.0))   GO TO 4200
      WORD(1:6)='      '
      CALL RFFORM(WORD,80,AY(I,1),NOPT,4,ISTAT)
      AY(I,5)=1.0
      CALL REVYAX(AY,I,NOPT)
 4200 CONTINUE
C
      DO 4250   K1=1,80,4
      K2=K1+3
      WORD(K1:K2)='    '
 4250 CONTINUE
C
      GO TO 3500
C  END OF LOOP FOR DEFINITION OF PLOT AXES.
 4400 GO TO(4600,3000,4600,4600,4600,4600,4600,4600,4600,3000,
     &      3000,4600,3000,3000,3000,3820),I
 4500 CONTINUE
      WRITE(LUPRT,460)OPTION,OPT
      RETURN 1
C
C
C   READING OF INPUT DATA FOR TLRAN,TLAVR,TLDEP,TLAVF,ANGLE
C   PHASE, CONDR, CONDA, AND CONFR OPTIONS.
C
 4600 CONTINUE
C   READING OF RMIN,RMAX,DELR IN KILOMETERS.
C   VALUES ARE THEN CONVERTED TO METERS.
C     BACKSPACE 20
C     READ(20,*)(SECD(I,K),K=1,3)
      CALL RFFORM(WORD,80,SECD(I,1),NOPT,3,ISTAT)
      SECD(I,1)=SECD(I,1)*1000.
      SECD(I,2)=SECD(I,2)*1000.
      SECD(I,3)=SECD(I,3)*1000.
      IF(SECD(I,1) .EQ. SECD(I,2)) THEN
        SECD(I,3)=1.0
      ELSE
        IF( ABS((SECD(I,2)-SECD(I,1))/SECD(I,3)) + 1 .GT. NRANGE)THEN
         WRITE(6,790) ALPHA1(I),NRANGE
         IF(LUPRT .NE. 6)   WRITE(LUPRT,790) ALPHA1(I),NRANGE
         STOP
        END IF
      END IF
      IF(ALPHA1(I).EQ.'TLAVF') THEN
       NPR=(SECD(I,2)-SECD(I,1))/SECD(I,3)+1
       IF(ABS((NPR-1)*SECD(I,3)+SECD(I,1)-SECD(I,2))
     $  .GT.1.0E-4*SECD(I,3))THEN
        NPR=NPR+1
       END IF
       IF(NPR.GT.NR1) THEN
        SECD(I,2)=SECD(I,1)+(NR1-1)*SECD(I,3)
        NR2=NR1
        WRITE(LUPRT,738)NR2
       END IF
      END IF
      IF((ALPHA1(I).NE.'CONDR').AND.(ALPHA1(I).NE.'CONFR').
     *AND.(ALPHA1(I).NE.'CONDA'))   GO TO 4800
      IF(I.EQ.8)   ICON=1
      IF(I.EQ.9)   ICON=2
      IF(I.EQ.12)  ICON=3
C   ZMIN,ZMAX,DELZ
      READ(20,*)(CNTR1(ICON,L),L=1,3)   
 4800 CONTINUE
C   REVISING OF XAXIS (RANGE OR FREQUENCY)
      GO TO(4900,2900,4900,5800,5200,5800,5800,4900,4900,2900,
     *2900,4900,2900,2900,2900,2900),I
C
C   REVISING OF "X" AXIS FOR TLRAN,TLAVR,CONDR,CONFR,
C   AND CONDA OPTIONS.
C
 4900 CONTINUE
      IF((FLAG(I,3).LT.1.0).AND.(STORE(I).LT.1.0))   GO TO 5500
      IF(AX(I,5).GT.0.0)   GO TO 5000
C    MIN VALUE
      AX(I,1)=SECD(I,1)  
C   MAX VALUE
      AX(I,2)=SECD(I,2)  
      GO TO 5500
 5000 IF(AMAX1(SECD(I,1),AX(I,1)).LT.AMIN1(AX(I,2),SECD(I,2)))GO TO 5100
      WRITE(LUPRT,710) ALPHA1(I),SECD(I,1),SECD(I,2),AX(I,1),AX(I,2)
      RETURN 1
 5100 IF(SECD(I,1).LT.AX(I,1))   SECD(I,1)=AX(I,1)
      IF(SECD(I,2).GT.AX(I,2))   SECD(I,2)=AX(I,2)
      GO TO 5500
C
C   REVISING OF X AXIS FOR 'TLAVF' OPTION.
C
 5200 CONTINUE
      IF(AX(I,5).GT.0.0)   GO TO 5300
      AX(I,1)=FF(1)
      AX(I,2)=FF(NFREQ)
 5300 CONTINUE
      IF(FLAG(I,3).LT.1.0)   GO TO 5800
      NXVAL=ALOG(AX(I,2)/AX(I,1))/ALOG(2.0)*AX(I,4)+1
      IF(NXVAL.LE.NINC)   GO TO 5800
C     WRITE(LUPRT,*)AX(I,1),AX(I,2),AX(I,4)
      WRITE(LUPRT,415) NINC
      WRITE(LUPRT,410)
      RETURN 1
 5500 CONTINUE
C
C   REVISING OF Y AXIS (LOG) FOR 'CONFR' AND 'CONDA' OPTIONS.
C
      IF((ALPHA1(I).NE.'CONFR').AND.(ALPHA1(I).NE.'CONDA'))  GO TO 5800
      IF(AY(I,5).GT.0.0)   GO TO 5600
      AY(I,1)=FF(1)
      AY(I,2)=FF(NFREQ)
 5600 CONTINUE
      IF(AY(I,1).GT.0.0)   GO TO 5700
      WRITE(LUPRT,421) ALPHA1(I)
      RETURN 1
 5700 CONTINUE
      NYVAL=ALOG(AY(I,2)/AY(I,1))/(ALOG(2.0)*AY(I,4))+1
      IF(NYVAL.LE.NINC)   GO TO 5800
      WRITE(LUPRT,420) ALPHA1(I),NINC
      WRITE(LUPRT,410)
      RETURN 1
 5800 CONTINUE
C
C   READING OF SOURCE/RECEIVER DEPTHS
C
      FLAGSD=0.0
      FLAGRD=0.0
      DO   6300   K=1,KSRDP1
      GO TO(5900,2900,6000,6000,6000,5900,6000,6000,5900,2900,
     *2900,6000,2900,2900,2900,2900),I
C5900 READ(20,*,ERR=6500,END=6600)TEMP1,TEMP2
 5900 CONTINUE
      READ(20,125) WORD
      IF(WORD(1:4).EQ.'@EOF')   GO TO 6800
C     BACKSPACE 20
C     READ(20,*,IOSTAT=ISTAT)TEMP1,TEMP2
      CALL RFFORM(WORD,80,BUFFIN,1,2,ISTAT)
      IF(ISTAT.GT.0)   GO TO 6500
      TEMP1=BUFFIN(1)
      TEMP2=BUFFIN(2)
      IF(K.GT.KSRD)   GO TO 6400
C
C   RECEIVER DEPTH IS CHECKED HERE:
C
      IF(TEMP2.LE.0.0.OR.TEMP2.GT.H0)   FLAGRD=1.0
      SRD(I,K,2)=TEMP2
      GO TO 6100
C6000 READ(20,*,ERR=6500,END=6800)TEMP1
 6000 CONTINUE
      READ(20,125)WORD
      IF(WORD(1:4).EQ.'@EOF')   GO TO 6800
C     BACKSPACE 20
C     READ(20,940,IOSTAT=ISTAT) TEMP1
      CALL RFFORM(WORD,80,TEMP1,1,1,ISTAT)
      IF(ISTAT.NE.0)   GO TO 6500
      IF(K.GT.KSRD)   GO TO 6400
C
C   SOURCE DEPTH IS CHECKED HERE:
C
 6100 IF(TEMP1.LE.0.0.OR.TEMP1.GT.HSTART)   FLAGSD=1.0
      IF(FLAGSD+FLAGRD.LT.1.0)   GO TO 6200
      IF(FLAGSD.GT.0.0)   WRITE(LUPRT,480) ALPHA1(I),TEMP1,HSTART
      IF(FLAGRD.GT.0.0)   WRITE(LUPRT,481) ALPHA1(I),TEMP2,H0
      RETURN 1
 6200 SRD(I,K,1)=TEMP1
 6300 CONTINUE
 6400 WRITE(LUPRT,500)
      RETURN 1
 6500 CONTINUE
      IF(K.EQ.1)   GO TO 6900
      REREAD=1
C     REREAD=0
      GO TO 3000
 6800 CONTINUE
      IF(K.GT.1)   GO TO 7000
 6900 WRITE(LUPRT,820) ALPHA1(I)
      RETURN 1
C
C
 7000 CONTINUE
C
C   REVISING OF X AXIS FOR 'GROUP' OPTION
C
C   'GROUP' OPTION
      I=2
      IF(FLAG(I,1).LT.1.0)   GO TO 7080
      IF(AX(I,5).GT.0.0)   GO TO 7040
C   MIN VALUE
      AX(I,1)=FF(1)   
C   MAX VALUE
      AX(I,2)=FF(NFREQ)   
      GO TO 7080
 7040 CONTINUE
      IF(AMAX1(FF(1),AX(I,1)).LT.AMIN1(AX(I,2),FF(NFREQ)))GO TO 7080
      WRITE(LUPRT,720) ALPHA1(I),FF(1),FF(NFREQ),AX(I,1),AX(I,2)
      RETURN 1
 7080 CONTINUE
C
C   REVISING OF X AND Y AXES FOR "PROFL" OPTION
C
C   'PROFL' OPTION
      I=10
      IF(AY(I,2).EQ.-1.0)   THEN
C   DEFAULT VALUE FOR Y AXIS LENGTH WILL BE 12 CM
       AY(I,2)=HMAX
       AY(I,3)=HMAX/12.
       AY(I,4)=HMAX/5.
      END IF
      IF(AX(I,2).EQ.-1.0)   THEN
C   DEFAULT VALUE FOR X AXIS LENGTH WILL BE 20 CM
       AX(I,2)=RST*1.0E-3
       AX(I,3)=RST/20. * 1.0E-3
       AX(I,4)=RST/5. *.10E-3
      END IF
C
C   REVISING OF Y AXIS FOR OPTION CONDR
C
      I=8
      IF(FLAG(I,1) .GT. 0.0)   THEN
       IF(HMIN.NE.HMAX)   THEN
        WRITE(LUPRT,753) HMIN,HMAX
        STOP
       END IF
       IF(AY(I,5) .EQ. 0.0 )   THEN
        AY(I,1)=0.0
        AY(I,2)=HMIN
       ELSE
        IF(AY(I,1) .GE. HMIN)   THEN
         WRITE(LUPRT,*) ' REVISE Y AXIS DEFINITION FOR OPTION CONDR '
         STOP
        ELSE
         IF((AY(I,2)-HMIN)/HMIN .GE. 1.0E-3)   THEN
         WRITE(LUPRT,752) HMIN,AY(I,2)
         AY(I,2)=HMIN
         END IF
        END IF
       END IF
      END IF
C  
C   REVISING OF Y AXIS FOR 'HORWN' OPTION
C
C   'HORWN' OPTION
      I=13
      IF(FLAG(I,1).LT.1.0)   GO TO 7081
      IF(AY(I,5).GT.0.0)   GO TO 7041
C   MIN VALUE
      AY(I,1)=FF(1)   
C   MAX VALUE
      AY(I,2)=FF(NFREQ)   
      GO TO 7081
 7041 CONTINUE
      CHKMIN=AMIN1(AY(I,1),AY(I,2))
      CHKMAX=AMAX1(AY(I,1),AY(I,2))
      IF(AMAX1(FF(1),CHKMIN).LT.AMIN1(CHKMAX,FF(NFREQ)))GO TO 7081
      WRITE(LUPRT,721) ALPHA1(I),FF(1),FF(NFREQ),AY(I,1),AY(I,2)
      RETURN 1
 7081 CONTINUE
C
C   CHECK IF AXES EXCEED THE MAXIMUM AVAILABLE PAPER SIZE.
C
C   MAX AXIS IN CM
      AMAX=118.9   
C   MIN AXIS IN CM
      AMIN=84.1 
      FLAGAX=0.0
      DO 7500   I=1,NOPT
      IF(FLAG(I,1).LT.1.0)   GO TO 7500
      IF(FLAG(I,3).LT.1.0)   GO TO 7500
      IF(ALPHA1(I).EQ.'TLAVF')   GO TO 7100
      AXL=ABS(AX(I,2)-AX(I,1))/AX(I,3)
      GO TO 7200
 7100 AXL=ALOG10(AMAX1(AX(I,2),AX(I,1))/AMIN1(AX(I,1),AX(I,2)))/
     *ALOG10(2.0)*AX(I,3)
 7200 CONTINUE
      IF((ALPHA1(I).EQ.'CONFR').OR.(ALPHA1(I).EQ.'CONDA'))  GO TO 7300
      AYL=ABS(AY(I,2)-AY(I,1))/AY(I,3)
      GO TO 7400
 7300 AYL=ALOG10(AMAX1(AY(I,2),AY(I,1))/AMIN1(AY(I,1),AY(I,2)))/
     *ALOG10(2.0)*AY(I,3)
 7400 CONTINUE
      IF((AMAX1(AXL,AYL)+7.0).GT.AMAX)   FLAGAX=-1.0
      IF((AMIN1(AXL,AYL)+6.0).GT.AMIN)   FLAGAX=-1.0
      IF(FLAGAX.GT.-1.0)   GO TO 7500
      FLAG1=-1.0
      WRITE(LUPRT,840) ALPHA1(I),AMAX,AMIN
      IF(AXL.GE.AYL)   WRITE(LUPRT,860) AXL,AYL
      IF(AXL.LT.AYL)   WRITE(LUPRT,880) AYL,AXL
      FLAGAX=0.0
 7500 CONTINUE
C
C   CHECK ON MINIMUM NUMBER OF FREQUENCIES FOR 'CONFR',
C   'CONDA' AND 'HORWN' OPTIONS.
C
      DO 7600   IOP=1,3
      ICOUNT=0
C   ALPHA1(I)='CONFR'
      IF(IOP.EQ.1)   I=9     
C   ALPHA1(I)='CONDA'
      IF(IOP.EQ.2)   I=12    
C   ALPHA1(I)='HORWN'
      IF(IOP.EQ.3)   I=13    
      IF(FLAG(I,1).LT.1.0)   GO TO 7600
      ICOUNT=0
      YMIN=AY(I,1)-1.0E-4*AY(I,1)
      YMAX=AY(I,2)+1.0E-4*AY(I,2)
      DO 7550   K=1,NFREQ
      IF((FF(K).GE.YMIN).AND.(FF(K).LE.YMAX)) ICOUNT=ICOUNT+1
 7550 CONTINUE
      IF(ICOUNT.GE.2)   GO TO 7600
      WRITE(LUPRT,740) ALPHA1(I)
      WRITE(LUPRT,739)
      DO 7551 K=1,NFREQ
      WRITE(LUPRT,741)K,FF(K)
 7551 CONTINUE
      WRITE(LUPRT,742)AY(I,1),AY(I,2)
      FLAG1=-1.0
 7600 CONTINUE
C   TEMPORARY STATEMENT TO JUMP PRINT OUT
C   CHKT IS KEY WORD
      IF(TITLE(1).NE.'CHKT')   GO TO 7800
      WRITE(LUPRT,220)(ALPHA2(I),I=2,6)
      WRITE(LUPRT,240)(ALPHA1(M),(FLAG(M,N),N=1,ICF),M=1,NOPT)
      DO 7750   IOP=1,NOPT
      IF(FLAG(IOP,1).LT.1.0)   GO TO 7750
      GO TO(7650,7750,7650,7650,7650,7650,7650,7650,7650,7750,
     *7750,7650,7750,7750,7750,7750),IOP
 7650 CONTINUE
      WRITE(LUPRT,260) ALPHA1(IOP)
      DO 7700   K=1,KSRD
      IF(SRD(IOP,K,1).GT.0.0) WRITE(LUPRT,*) SRD(IOP,K,1),SRD(IOP,K,2)
 7700 CONTINUE
 7750 CONTINUE
      WRITE(LUPRT,280)
      WRITE(LUPRT,300)(ALPHA1(M),(SECD(M,N),N=1,3),M=1,NOPT)
      WRITE(LUPRT,380)
C   OPTION CONDR
      WRITE(LUPRT,400) ALPHA1(8),(CNTR1(1,N),N=1,3)
C   OPTION CONFR
      WRITE(LUPRT,400) ALPHA1(9),(CNTR1(2,N),N=1,3)
C   OPTION CONDA
      WRITE(LUPRT,400) ALPHA1(12),(CNTR1(3,N),N=1,3)
 7800 CONTINUE
      IF(FLAG1.GT.-1.0)   GO TO 7900
      WRITE(LUPRT,680)
      RETURN 1
 7900 CONTINUE
      CLOSE(20)
      DO 7920   I=1,NOPT
      IF(SECD(I,1) .EQ. SECD(I,2))   SECD(I,3)=0.0
 7920 CONTINUE
      RETURN
      END

      SUBROUTINE IPULSE(WORD,ALPHA1,FLAG,SECD,PULSD,NSD,NK,NOPT,
     & I,KSRD,ICF,HSTART,LUIN)
C
      CHARACTER*5 ALPHA1(NOPT)
      CHARACTER*80 WORD

      DIMENSION BUFFIN(4)
      DIMENSION PULSD( NSD ), FLAG(NOPT,ICF), SECD(NOPT,3)

      COMMON /CFIELD/ FLDRD(3),PULRD(3)
      COMMON /LUNIT/ MSOURC,MODOLD,MODNEW,LUPRT
      COMMON /PULSED/ FMIN, FMAX, DELTAT, NFFT

  200 FORMAT(A80)
  300 FORMAT(1H ,' REVISE THE FOLLOWING INPUT LINE:',/,1X,A80,/,
     & '  SPECIFIED FOR OPTION "',A5,'" ',/,
     & '  EXECUTION IS TERMINATED ')
  320 FORMAT(1X,/,' ****  WARNING ****     THE FOLLOWING INPUT LINE:'
     & ,//,1X,A80,//,
     & '    READ FOR OPTION "',A5,'"  WILL BE DECODED AS THE DEPTH',
     & ' SPECIFICATION',/,'    OF A  " SINGLE SOURCE "  CASE. ',/)
  400 FORMAT(1H ,//,' THE RECEIVER DEPTH SPECIFICATION FOR OPTION "',
     & A5,'" IS NOT CORRECT. ',/,'  INPUT LINE : ',1X,A80,/,
     & ' MIN RECEIVER DEPTH = ',F10.3,/,
     & ' MAX RECEIVER DEPTH = ',F10.3,/,
     & ' STEP               = ',F10.3,/,
     &  ' EXECUTION IS TERMINATED')
  500 FORMAT(1H ,//,' THE FOLLOWING SOURCE DEPTH SPECIFICATION',
     & ' FOR OPTION "',A5,
     &'" IS NOT CORRECT. ',/,'  SOURCE DEPTH ',F10.3,' m',/,
     &  ' EXECUTION IS TERMINATED')
  600 FORMAT(1H ,//,
     & ' *** WARNING : TOO MANY SOURCE DEPTHS HAVE BEEN SPECIFIED',
     & ' FOR OPTION PULSE. ',/,
     & '               THE MAXIMUM ALLOWED QUANTITY IS ',I3,'.',/,
     & '               THE EXECUTION WILL COVER THE FIRST',
     & ' SOURCES ONLY.',/)
  620 FORMAT(1H ,//,
     & ' *** ERROR : INSUFFICIENT NUMBER OF SOURCE DEPTHS FOR',
     & ' OPTION "',A5,'"',/,' EXECUTION IS TERMINATED')
  640 FORMAT(1H ,//,
     & ' *** ERROR IN READING SOURCE DEPTHS FOR OPTION "',
     &  A5,'"',/,' EXECUTION IS TERMINATED')
C
      CALL RFFORM(WORD,80,BUFFIN,1,4,ISTAT)
      IF(ISTAT .GT. 0)   THEN
       WRITE(LUPRT,300) WORD,ALPHA1(I)
       STOP ' STOP 1 IN SUB IPULSE '
      END IF
      NFFT=BUFFIN(1)
      FMIN=BUFFIN(2)
      FMAX=BUFFIN(3)
      DELTAT=BUFFIN(4)
      DELTAT=DELTAT
      IF( DELTAT.LE.0.0)   THEN
      WRITE(LUPRT,*)' REVISE DELTAT FOR OPTION PULSE, DELTAT= ',DELTAT
      STOP ' STOP 2 IN SUB IPULSE '
      END IF
C   READING OF RMIN,RMAX AND STEP INCREMENT IN KILOMETERS.
      READ(LUIN,200)WORD
      CALL RFFORM(WORD,80,BUFFIN,1,3,ISTAT)
      IF(ISTAT .GT. 0)   THEN
       WRITE(LUPRT,300) WORD, ALPHA1(I)
       STOP ' STOP 3 IN SUB IPULSE '
      END IF
      SECD(I,1)=BUFFIN(1)*1000.
      SECD(I,2)=BUFFIN(2)*1000.
      SECD(I,3)=BUFFIN(3)*1000.
      IF(SECD(I,1) .EQ. SECD(I,2))   SECD(I,3)= 0.0
      
C
C   READING OF MIN, MAX RECEIVER DEPTH AND STEP INCREMENT
C
      READ(LUIN,200) WORD
      CALL RFFORM(WORD,80,BUFFIN,1,3,ISTAT)
      IF(ISTAT .GT. 0)   THEN
       WRITE(LUPRT,300) WORD, ALPHA1(I)
       STOP ' STOP 4 IN SUB IPULSE '
      END IF
      PULRD(1)=BUFFIN(1)
      PULRD(2)=BUFFIN(2)
      PULRD(3)=BUFFIN(3)
      IF( (PULRD(1) .LT. 0.)                      .OR.
     &    (PULRD(1) .GT. HSTART)                  .OR.
     &    (PULRD(2) .LE. 0.)                      .OR.
     &    (PULRD(2) .GT. HSTART)                  .OR.
     &    (PULRD(3) .LT. 0.)                      .OR.
     &    (PULRD(3) .GT. (PULRD(2)-PULRD(1)))     .OR.
     &    (PULRD(1) .GT. PULRD(2)))                    THEN
       WRITE(LUPRT,400) ALPHA1(I), WORD, (BUFFIN(J),J=1,3)
       STOP ' STOP 5 IN SUB IPULSE '
      END IF

C   READING OF number of source depths , and actual SDs

      READ(LUIN,200)   WORD
      BUFFIN(1)= 0.0
      BUFFIN(2)= 0.0
      CALL RFFORM(WORD,80,BUFFIN,1,2,ISTAT)
      IF(ISTAT .GT. 0)   THEN
       WRITE(LUPRT,300) WORD, ALPHA1(I)
       STOP ' STOP 4 IN SUB IPULSE '
      END IF


C **** THIS R.D. ADIABATIC VERSION WILL ALLOW FOR "ONE" SOURCE DEPTH ONLY.
C **** PROGRAM LINES COMMENTED OUT WITH A "CX" SYMBOL WOULD BE NEEDED
C **** IC CASE A MULTIPLE SOURCE VERSION OF THE "PULSE" OPTION IS IMPLEMENTED.
CX      IF(BUFFIN(2) .EQ. 0.)   THEN
        NK= 1
        PULSD(1)= BUFFIN(1)
CX        WRITE(6,320) WORD, ALPHA1(I)
CX      ELSE
CX        NK= BUFFIN(1)
CX        IF(NK .GT. NSD )   THEN
CX          WRITE(6,600) NSD
CX        END IF
CX        BACKSPACE (LUIN)
CX        READ(LUIN,*,END=1200, ERR= 1400) NK, ( PULSD(J), J= 1, NK )
CX        NK= MIN(NK,NSD)
CX      END IF

C CHECK DATA CONSISTENCY

      DO 1000 JK= 1, NK
      IF( (PULSD( JK ) .LT. 0.)  .OR.
     &    (PULSD( JK ) .GT. HSTART) )         THEN
       WRITE(LUPRT,500) ALPHA1(I), PULSD(JK)
       STOP ' STOP 8 IN SUB IPULSE '
      END IF
 1000 CONTINUE
      RETURN
 1200 CONTINUE
      WRITE(6,620) ALPHA1(I)
      STOP
 1400 WRITE(6,640) ALPHA1(I)
      STOP
      END
