      SUBROUTINE PHASE(NP,*,F,IB,TITLE,IOP,RNG,US,UROLD,URNEW,
     & XT1,XT2,ISP1,NSECT)
C
C   MSP IS NUMBER OF POINTS USED TO SAMPLE THE DEPTH
C   FUNCTIONS. IT IS ALSO DEFINED IN SUB TLDEP AND DRIVER
      PARAMETER (MSP=51,ISD=5,MODNP=10)
C
      LOGICAL IB
      CHARACTER*3 XBTYPE, YBTYPE
      CHARACTER*4 TITLE(20), TITLEX, TITLEY, DM
      CHARACTER*6 PHS(2)
      CHARACTER*9 OPTION
      CHARACTER*80 TIX, TIY
      INCLUDE 'COMMON.FOR'
      REAL*8 EKNEW,EKFST,EKOLD,EKAVR
      DIMENSION XT1(12,MSP),XT2(12,MSP)
      DIMENSION RNG(NRANGE),FASE(NRANGE)
      DIMENSION TLUS(ISD,MODEN),PHGLOB(ISD,MODNP,MSP),XBUF(MSP),
     & YBUF(MSP)
      DIMENSION US(MODEN),UROLD(2,MODEN),URNEW(2,MODEN)
      EQUIVALENCE (TIX,TITLEX),(TIY,TITLEY)
      COMMON/B/ALFNEW(MODEN)
      COMMON/C/EKNEW(MODEN)
      COMMON/D/EKFST(MODEN),EKOLD(MODEN),EKAVR(MODEN),
     & ALFOLD(MODEN),ALFAVR(MODEN)
      COMMON/I/SECD(NOPT,3)
      COMMON/N/MINMOD,MAXMOD,HORIG,NFREQ
      COMMON/NRNGD/HNEW,HOLD,RSTART,REND,SLNGTH,IND1
      COMMON/LUNIT/MSOURC,MODOLD,MODNEW,LUPRT
      COMMON/SAVE/STORE(NOPT),IFREQ
      COMMON/XAX/X1,XL,XLEFT,XRIGHT,XSCALE,XINC,DX,
     & XDUM3,XDUM4,IXDUM1,XDUM5,XDUM6,DIVX,XVAL(100),NXVAL
      COMMON/XAXC/TITLEX(20),XBTYPE
      COMMON/YAX/Y1,YL,YUP,YDOWN,YSCALE,YINC,DY,
     & YDUM3,YDUM4,IYDUM1,YDUM5,YDUM6,DIVY,YVAL(100),NYVAL
      COMMON/YAXC/TITLEY(20),YBTYPE
      DATA OPTION/'PHASE,   '/
      DATA PHS/'PHASE(','deg)  '/
      DATA DM/' m  '/
      DATA DEGCON/57.29578/,TWOPI/6.283185/,PI/3.141593/
      DATA I3,I4,I5,R1,R2/3*0,2*0.0/
      DATA NTIMES/1/

  300 FORMAT(1H ,///,'   PHASE OF ACOUSTIC FIELD VERSUS DEPTH',//,'   FR
     &EQUENCY    =', F8.1,' Hz',/,'   WATER DEPTH  =', F8.1,' m',/,'   R
     &ANGE        =',F8.1,' km')
  310 FORMAT(1H ,//,'  SOURCE DEPTH:',5X,10(F7.1,A2,3X))
  320 FORMAT(1H ,/,'  DEPTH(m) ',10X,10(A6,A4,2X))
  400 FORMAT(1H ,F6.1,8X,5(3X,F9.2))
  402 FORMAT(1H1)
  820 FORMAT('Phas','e (d','egre','es) ',16('    '))
  840 FORMAT('Dept','h (m',')   ',17('    '))
C
C  DEFINITION OF CONSTANTS.
C
C
      PRT=FLAG(IOP,2)
      PLT=FLAG(IOP,3)
      XLEFT=AX(IOP,1)
      XRIGHT=AX(IOP,2)
      XSCALE=AX(IOP,3)
      XINC=AX(IOP,4)
      YUP=0.0
      YSCALE=AY(IOP,3)
      YINC=AY(IOP,4)
      COH=FLAG(IOP,5)
      MODQTY=MAXMOD-MINMOD+1
      H0STEP=HORIG/(MSP-1)
      DELTA=REND-RSTART
      MSP1=2
      MSP2=MSP
C
C
C   USED TO AVOID UNSTABILITY IN THE SINGLE MODE CASE DUE TO 
C   ROUND-OFF ERRORS
      EPS=5.0E-6   
      IF(PRT.GT.0.0)   WRITE(LUPRT,402)
C
C  SEARCH OF INDEXES RELATED TO PHASE IN THE SRD MATRIX.
C
      NSTART=1
      DO 1400   K=1,KSRD
 1400 IF(SRD(IOP,K,1).LE.0.0)   GO TO 1600
 1600 NEND=K-1
      NMBSD=ISD
 1700 IF((NEND-NSTART+1).GE.NMBSD)   GO TO 1800
      NMBSD=NEND-NSTART+1
      IF(NMBSD.EQ.0)   GO TO 6000
 1800 CONTINUE
C
C   LOOP FOR STORING MODE AMPLITUDES AT SOURCE DEPTH.
C
      DO 2000   I=1,NMBSD
      CALL SOURCE(SRD(IOP,NSTART-1+I,1),MODQTY,*6000,XT1,MSP,US)
      DO 2000   M=1,MODQTY
 2000 TLUS(I,M)=US(M)
C
C
      DO 5500   NP1=1,NP,MODNP
      NP2=NP1+MODNP-1
      IF(NP2.GT.NP)   NP2=NP
      DO 2200 ID1=MSP1,MSP2,2
      ID2=MIN(ID1+1,MSP2)
      CALL RECVRN(ID1,ID2,MODQTY,ISP1,NSECT,MSP,UROLD,
     & URNEW,XT1,XT2,MODEN)
      DO 2200   IS=1,NMBSD
      DO 2120   M=1,MODQTY
 2120 US(M)=TLUS(IS,M)
      DO 2150 ID=ID1,ID2
      CALL PHASES(NP1,NP2,RNG,FASE,US,UROLD,URNEW,EKNEW,
     & EKFST,EKOLD,EKAVR,ALFOLD,ALFAVR,ALFNEW,MODEN,ID-ID1+1,
     & NRANGE)
      DO 2140   IR=NP1,NP2
      IRMOD=MOD(IR-1,MODNP)+1
      PHGLOB(IS,IRMOD,ID)=FASE(IR)
2140  CONTINUE
2150  CONTINUE
2200  CONTINUE
      DO 2250   IS=1,NMBSD
      DO 2250   IR=NP1,NP2
      IRMOD=MOD(IR-1,MODNP)+1
C   PHASE AT DEPTH 0.0M IS NOT CALCULATED
 2250 PHGLOB(IS,IRMOD,1)=0.0   
C  THE PHASE ANGLE IS SHIFTED SO THAT ITS STARTING VALUE
C  IS ALWAYS ZERO.
      DO 2300   IS=1,NMBSD
      DO 2300   IR=NP1,NP2
      IRMOD=MOD(IR-1,MODNP)+1
      SHIFT=TWOPI-PHGLOB(IS,IRMOD,2)-EPS
      PHGLOB(IS,IRMOD,2)=0.0
      DO 2300   ID=3,MSP
      PH=PHGLOB(IS,IRMOD,ID)
      PH=AMOD(PH+SHIFT,TWOPI)
      IF(PH.GT.PI)   PH=PH-TWOPI
 2300 PHGLOB(IS,IRMOD,ID)=PH*DEGCON
      IF(PRT.LT.1.0)   GO TO 2500
      DO 2400   IR=NP1,NP2
      IRMOD=MOD(IR-1,MODNP)+1
      HH=HOLD+(HNEW-HOLD)*(RNG(IR)-RSTART)/DELTA
      RKM=RNG(IR)*1.0E-3
      WRITE(LUPRT,300)F,HH,RKM
      WRITE(LUPRT,310)(SRD(IOP,K,1),DM,K=NSTART,NEND)
      WRITE(LUPRT,320) (PHS(1),PHS(2),K=NSTART,NEND)
      DO 2400   ID=1,MSP
      YBUF(ID)=HH*(ID-1)/(MSP-1)
 2400 WRITE(LUPRT,400)YBUF(ID),(PHGLOB(IS,IRMOD,ID),IS=1,NMBSD)

 2500 IF(PLT.LT.1.0)   GO TO 5000
      XBTYPE='LIN'
      YBTYPE='LIN'
      DIVX=1.0
      DIVY=1.0

      WRITE(TIX,820)
      WRITE(TIY,840)

      FSTOP=1.0
      DO 4000   IR=NP1,NP2
      IRMOD=MOD(IR-1,MODNP)+1
      HH=HOLD+(HNEW-HOLD)*(RNG(IR)-RSTART)/DELTA
      HSTEP=HH/(MSP-1)
      DO 2800 ID=1,MSP
      YBUF(ID)=(ID-1)*HSTEP
 2800 CONTINUE
      DO 4000   IS=1,NMBSD
      DO 3000   ID=1,MSP
 3000 XBUF(ID)=PHGLOB(IS,IRMOD,ID)
      K=IS+NSTART-1
      RR=RNG(IR)
C   TEMPORARY STATEMENT
      YDOWN=HH
      IF(AY(IOP,5).LT.1.0)THEN
      AY(IOP,1)=0.0
      AY(IOP,2)=HH
      END IF
      SD=SRD(IOP,K,1)
      RD=SRD(IOP,K,2)
      CALL PREP1(OPTION,TITLE,F,SD,RD,RR,YBUF,2,MSP,NTIMES)
      CALL PREP2(XBUF,F,SD,RD,RR,2,MSP,I3,I4,I5,HH,
     & R2,FSTOP)
 4000 CONTINUE
 5000 CONTINUE
 5500 CONTINUE
      NSTART=NSTART+NMBSD
      GO TO 1700
 6000 CONTINUE
      RETURN 1
C
      END
